#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "strutture.h"
#include "global.h"


segment(int lun, char stringa[], char *parola, int caso, FILE *fd)
{
  int isin(char target);               /* match di carattere */
  int output(char a[MAXLETTERE], int b, FILE *c); /* emette parola sillabata*/
  int coda(int d, char e[MAXLETTERE]); /*copia ultima 
                                        sillaba in parola sillabata */
  int inner(int f, int g, char h[MAXLETTERE],char *i); /* aggiorna parola 
                                        sillabata con sillaba corrente*/
  int eccezione1(char l[MAXLETTERE], int m, int n); /* valuta eccezioni */
  int eccezione2(char l[MAXLETTERE], int m, int n); /* valuta eccezioni */
  int stripchar(int o, int p, char l[MAXLETTERE], char *i); /*salva 
                                        in sillabato carattere singolo */
  int stripvoc(int o, char l[MAXLETTERE], char *i); /*salva 
                                        in sillabato vocale singola e mette - */
  int matchbivoc(char *i);  /* controlla di 
                                        che tipo sono due vocali consecutive */
  int matchtrivoc(char *i); /* controlla di 
                                        che tipo sono tre vocali consecutive */
  int init_voc();           /* inizializza stringa vocale accentata e gruppo 
                                        vocalico                             */ 

  int save_char(char q, int o);     /* salva vocale corrente in lettera_acc e 
                                        gruppo_vocalico                      */
  int pos_acc(char r[LA]);         /* da' la posizione dell'accento          */
  int ismarker(char q);            /* riconosce { o } nella stringa          */

  extern char sillabato[MAXLETTERE];
  extern char *sillabe;
  extern int curr_pos;

  extern char lettera_acc[LA]; /* contiene vocale accentata */
  extern char *pt_la;
  extern int  curr_la; /* posizione corrente su vettore lettera_acc          */
  extern char gruppo_vocalico[GV]; /* contiene gruppo vocalico */
  extern char *pt_gv;
  extern int  curr_gv; /* posizione corrente su vettore gruppo_vocalico      */

  int esito;
  int match_esito;
  int esci;
  int bak_len;     /* contiene lunghezza di potenziale sillaba            */
  int depth;       /* cursor su parola da sillabare, ogni chiamata va a 0 */
  int local_pt;
  int mask;        /* maschera di navigazione su albero delle scelte      */
  int accento;     /* dice quale e' la vocale accentata                   */
  int num_voc;     /* dice quante sono le vocali consecutive              */
  int salva;       /* dice se salvare  vocale o no                        */
  int fine_parola; /* dice se l'accento e' a fine parola o no             */
  int net_lun;     /* lunghezza parola al netto di accento corrente       */         
  int incr;        /* da' l'incremento di depth in presenza di accento    */

  char *bvv;
  char vett[4];

  char lettera;
  char close='\0';

  esci=NO;
  mask=1;  /* nessuna decisione */
  depth=0; /* a inizio "parola" */

  bvv=vett; /* inizializzo il puntatore */

  init_var();

  accento=1; /* 1 nessun accento, 2 V'VV, 4 VV'V, 8 VVV' */
  num_voc=0; /* nessuna vocale, se !=0 indice shift sinistro */

  lettera=stringa[depth];
  do
  {
   esito=isin(lettera);
   switch (esito) /* esito=1 se consonante, 0 se vocale, 2 se accentazione */
   {
     case 1:  /* consonante */
      mask=(mask<<1)+1;
      num_voc=0;
      if(accento==1)
       {
        init_var();
       }
      break;

     case 0: /* vocale, controllo anche il/i carattere/i  successivo/i */
      mask=(mask<<1);
      if(accento==1)
       {
        curr_la=0;
        pt_la=lettera_acc;
        salva=SI;
       }
      else
        salva=NO;
      save_char(lettera,salva); 
      num_voc++;
      fprintf(stdout,"num_voc0: %d\n",num_voc);
      local_pt=depth+1;
      break;

     default:
      fprintf(stderr,"carattere sconosciuto: %c\n",lettera);
      return ERROR;
   }
 
   fprintf(stdout,"lettera_accentata: %s\n",lettera_acc);
   fprintf(stdout,"gruppo_vocalico: %s\n",gruppo_vocalico);
   fprintf(stdout,"num_voc: %d\n",num_voc);
   fprintf(stdout,"accento: %d\n",accento);
   fprintf(stdout,"net_lun: %d\n",net_lun);
   fprintf(stdout,"mask= %d\n", mask);

   switch (mask)
     {
      case 2: /* V */
            if(lun==1) /* caso vocale isolata */
             {
               lun=coda(lun,stringa);
               esci=SI;
             }
            break;

      case 4: /* VV */
            if(lun==2) /* caso VV  isolate, da controllare */
             {
               lun=coda(lun,stringa);
               esci=SI;
             }
            strncpy(bvv,parola,BIS);
            *(bvv+BIS)='\0';
            esito=matchbivoc(bvv);
            match_esito=esito;
            if(match_esito==1)
              bak_len=1;
            if(match_esito==2)
              bak_len=2;
            if(esito==ERROR) 
              {
               fprintf(stderr,"Combinazione vocalica sconosciuta!!\n");
               return ERROR;   
              } 
            break;

      case 5: /* VC */
            bak_len=depth+1;
            if(lun==2) /* caso VC  isolate */
             {
               lun=coda(lun,stringa);
               esci=SI;
             }
            break;

      case 6: /* CV */
            bak_len=depth+1;
            if(lun==2) /* caso CV isolate */
              {
               lun=coda(lun,stringa);
               esci=SI;
              }
            break;             

      case 7: /* CC */
            lun=stripchar(lun,depth,stringa,parola);
            esci=SI;
            break;         

      case 8: /* VVV da fare */
            strncpy(bvv,parola,TRIS);
            *(bvv+TRIS)='\0';
            esito=matchtrivoc(bvv);
            return ERROR;

      case 9: /* VVC   */
            if(match_esito==1)
             {
              lun=stripvoc(lun,stringa,parola);
              esci=SI;
             }
            break;          
 
      case 10: /* VCV  */
            if(lun==3)
            {
             lun=stripvoc(lun,stringa,parola);
             esci=SI;
            }
            break;         

      case 11: /* VCC  */
            bak_len=depth+1;
            if(lun==3)
            {
             lun=coda(lun,stringa);
             esci=SI;
            }
            break;         

      case 12: /* CVV */
            strncpy(bvv,++parola,2);
            *(bvv+2)='\0';
            parola--;
            esito=matchbivoc(bvv); /* esito=1 da separare,
                                      esito=2 dittongo, non ancora decidibile 
                                      esito=ERROR  errore nella ricerca
                                    */
            match_esito=esito;
            if(esito==1)
              {
               lun=stripchar(lun,1,stringa,parola);
               lun=stripvoc(lun,stringa,parola);
               esci=SI;
              }
            if(esito==2)
              {
               if(lun==3) /* caso  CV  da solo o a fine parola */ 
               {
                lun=coda(lun,stringa);
                esci=SI;
               }
              }
            if(esito==ERROR) 
              {
               fprintf(stderr,"Combinazione vocalica sconosciuta!!\n");
               return ERROR;   
              } 
           break;
 
      case 13: /* CVC */
            if(lun==3)
              {
               lun=coda(lun,stringa);
               esci=SI;
              }
            break;

      case 18: /* VVCV con VV dittongo */
            lun=stripchar(lun,1,stringa,parola);
            lun=stripvoc(lun,stringa,parola);
            esci=SI;
            break;

      case 19: /* VVCC con VV dittongo */
            lun=stripchar(lun,1,stringa,parola);
            esci=SI;
            break;

      case 20: /* VCVV  */
            lun=stripvoc(lun,stringa,parola);
            esci=SI;
            break;         
 
      case 21: /* VCVC  */
            lun=stripvoc(lun,stringa,parola);
            esci=SI;
            break;         
 
      case 22: /* VCCV */
            fprintf(stdout,"VCCV\n");
            bak_len--;
            bak_len=eccezione2(stringa,bak_len,depth);
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;

      case 24: /* CVVV da fare*/
            return ERROR;
   
      case 25: /* CVVC */
            fprintf(stdout,"CVVC\n");
            bak_len=depth;
            break;

      case 26: /* CVCV */
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;
  
      case 27: /* CVCC */
            bak_len=depth;
            break;
   
      case 46: /* VCCCV */
            fprintf(stdout,"VCCCV\n");
            lun=inner(lun,bak_len-1,stringa,parola);
            esci=SI;
            break;

      case 47: /* VCCCC */
            fprintf(stdout,"VCCCC\n");
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;

      case 50:
            fprintf(stdout,"CVVCV\n");
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;

      case 51:
            fprintf(stdout,"CVVCC\n");
            lun=stripchar(lun,1,stringa,parola);
            lun=stripchar(lun,1,stringa,parola);
            esci=SI;
            break;

      case 54: /* CVCCV */
            fprintf(stdout,"CVCCV\n");
            bak_len=eccezione1(stringa,bak_len,depth);
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;
   
      case 55: /* CVCCC */
            bak_len=depth;
            break;

      case 110: /* CVCCCV */
            fprintf(stdout,"CVCCCV\n");
            lun=inner(lun,bak_len-1,stringa,parola);
            esci=SI;
            break;

      case 111: /* CVCCCC */
            fprintf(stdout,"CVCCCC\n");
            lun=inner(lun,bak_len,stringa,parola);
            esci=SI;
            break;
 
      default:
            bak_len=depth;
            break;
     }
   depth++;
   lettera=stringa[depth];

  } while (esci==NO);

  if(lun>0)
    segment(lun,stringa,parola,caso,fd);
  else
    output(sillabato,caso,fd);
  return 0;
}
